; IRC - Internet Relay Chat, src/s_serv.c
; Copyright (C) 1990 Jarkko Oikarinen and
;                    University of Oulu, Computing Center
;
; See file AUTHORS in IRC package for additional names of
; the programmers.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 1, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; $Id: irclen.asm,v 1.2 2002/05/11 03:49:07 smoli Exp $
;
; speed gain was 50%, compared to noarch on i686-pc-linux-gnu, athlon CPU
;
		global	irclen

[segment .text]

irclen:		push	esi
		push	ecx

		xor	ecx, ecx
		mov	esi, [esp + 0Ch]
		test	esi, 00000003h
		jz	.loop
		
.align:		test	byte [esi], 0xff
		jz	.exit
		inc	esi
		inc	ecx
		test	esi, 00000003h
		jnz	.align

.loop:		lodsd
		test	al, al
		jz	.exit
		inc	ecx
		test	ah, ah
		jz	.exit
		inc	ecx

		ror	eax, 10h

		test	al, al
		jz	.exit
		inc	ecx
		test	ah, ah
		jz	.exit
		inc	ecx

		jmp	.loop

.exit:		pop	eax
		xchg	eax, ecx
                pop	esi
                ret
