#include <stdio.h>
#include <assert.h>

#include "irc_string.h"

int irccmp(const char *s1, const char *s2)
{
  const unsigned char* str1 = (const unsigned char*) s1;
  const unsigned char* str2 = (const unsigned char*) s2;
  int res;
  
  while((res = (to_upper(*str1)) - (to_upper(*str2))) == 0)
    {
      if (*str1 == '\0')
        return 0;
      str1++;
      str2++;
    }
  
  return (res);
}

