#include <assert.h>
#include "irc_string.h"

int ircncmp(const char* s1, const char *s2, int n)
{
  const unsigned char* str1 = (const unsigned char*) s1;
  const unsigned char* str2 = (const unsigned char*) s2;
  int res;
/*  assert(0 != s1);
  assert(0 != s2);*/

  while((res = to_upper(*str1) - to_upper(*str2)) == 0)
    {
      str1++; str2++; n--;
    
      if(n == 0 || (*str1 == '\0' && *str2 == '\0'))
        return 0;
    }
  
  return (res);
}

