/* simple password generator by Nelson Minar (minar@reed.edu)
 * copyright 1991, all rights reserved.
 * You can use this code as long as my name stays with it.
 *
 *
 * $Id: mkpasswd.c,v 1.6 2002/05/06 02:48:33 smoli Exp $
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <crypt.h>

int main()
{
  static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
  char salt[3];
  long seed;
  char *plaintext, *passwd;

  plaintext = getpass("Password: ");

  seed = time(NULL);

  for(;;)
    { 
      srandom(seed);
      salt[0] = saltChars[random() % 64];
      salt[1] = saltChars[random() % 64];
      salt[2] = 0;
      passwd = crypt(plaintext, salt);
      if(!strchr(passwd, '.') &&
         !strchr(passwd, '/'))
        break;
      seed -= 0x9e45ba93;
      seed ^= seed - 0x9e45ba93;
    }

  printf("%s\n", passwd);
  return 0;
}

